(* arithlex.mll : OCaml lex source file *)

(* First section is raw ocaml between curlies *)
{
  open Arithparse;;        (* Bring in token types from arithparse.mli *)
  exception Eof;;
}

(* second section defines how the lexer works *)
rule token = parse
 | [' ' '\t']        { token lexbuf }     (* skip blanks *)
 | ['\n' ]           { EOL }
 | ['0'-'9']+ as lxm { INT(int_of_string lxm) }
 | '+'               { PLUS }
 | '-'               { MINUS }
 | '*'               { TIMES }
 | '/'               { SLASH }
 | '('               { OPAREN }
 | ')'               { CPAREN }
 | eof               { raise Eof }

